#include "main.h"

/* Questa define va cambiata, ho assunto 256 di default */



/* Struttura dati dello list*/



/* 
 * Funzione di PUSH dello list.
 * -> Prende come PARAMETRO il puntatore al primo elemento dello list e il path-file da inserire
 * <- RESTITUISCE il puntatore al primo elemento dello list
 *
 */
 
list * push(list *head, char *string){

	list *newnode = NULL;
	list *temp = head;
	
	/* Creazione del nuovo nodo, copia del path-nomefile all'interno */
	newnode = (list *) malloc(sizeof(list));
	newnode->next = NULL;
	strcpy(newnode->absref,string);
	
	/* Se la lista e' vuota, questo e' il nuovo nodo
	 * altrimenti si scorre la lista e si aggiunge il
	 * nodo in cima allo list
	 */
	if(head == NULL){
		head = newnode;
	
	}else{
	
		while(temp->next != NULL){
			temp = temp->next; 
			
		}
		temp->next = newnode;
			
	}	

	return head;

}

/* 
 * Funzione di POP dello list.
 * -> Prende come PARAMETRO il puntatore al primo elemento dello list
 * <- RESTITUISCE il puntatore al primo elemento dello list
 *
 */
list * pop(list *head){

	list *victim = head;
	list *temp = head; 

	if(head == NULL) return NULL;
	
	if(head->next == NULL) {
		free(head);
		return NULL;		
	}
	
	victim = victim->next;
	while(victim->next != NULL) {
		victim = victim->next;
		temp = temp->next;
	}
	
	temp->next = NULL;
	free(victim);
	
	return head;
}

/*
 * Funzione di STAMPA dello list.
 * -> Prende come PARAMETRO il puntatore al primo elemento dello list
 * <- STAMPA tutte le stringhe dello list, partendo dalla prima inserita.
 *
 */
void printlist(list *head){

	list *print = head;
	
	while(print != NULL){
		printf("printlist() : Elemento -> %s\n",print->absref);
		print = print->next;
	}
	printf("FINELISTA\n");	
		
	return;

}


/*
 * Trasferisce su file il contenuto di uno list partendo dal primo elemento inserito.
 * ATTENZIONE: LA FUNZIONE LAVORA IN MODALITA' APPEND! Creare il file prima altrimenti:
 * 
 * open: No such file or directory
 * list2file() : errno -> Illegal seek
 *
 * -> Prende come PARAMETRO il puntatore al primo elemento dello list
 *
 */
void list2file(list *head,char *filename){

	list *ptr = head;
	char newline = '\n';
 	int fd = 0;
	int o; 
	extern int errno;
	
	/* Apro il file in read/write mode e append
	 * di modo che l'indicatore del file viene posto
	 * in apertura alla fine del file. Praticamente come
	 * fare un lseek su SEEK_END subito dopo una open.
	 */	
 	if((fd = open(filename,O_RDWR|O_APPEND)) < 0){
		perror("list2file() : open");
		printf("list2file() : %s\n",strerror(errno));
		errno = 0;		
 	}else{
	
		/* Fintantoche' ci sono elementi nello list
		 * i file vengono scritti sul file passato come
		 * parametro (char *filename).
		 */
		while(ptr != NULL){
		
			if((o = write(fd,ptr->absref,strlen(ptr->absref))) <0 ){
				perror("write");
				printf("list2file() : %s\n",strerror(errno));
				errno = 0;
			}
			
			if((o = write(fd,&newline,1)) <0 ){
				perror("write");
				printf("list2file() : %s\n",strerror(errno));			
				errno = 0;
			}			
			
			
			ptr = ptr->next;
		
		}
	}
	
  	close(fd);

}


