#include "main.h"

#define SOGLIALEN 13

void leggi_fileout (int f_in,char *fileout)
{
	int i = 0;
	char c = '\0';
	int nread = 1; //anche = 0??
	
	ignora_spazi(f_in);
	
	while((nread=read(f_in,&c,sizeof(char))) != 0 && (c != '\n') && (i < MAXLEN-1)) 
		fileout[i++] = c;
	
	if(nread == 0) {
		perror("End of File inatteso");
		exit(1);
	}
	else if (i>= MAXLEN-1) {
		perror("Lunghezza del nome eccessiva");
		exit(2);
	}
	
	fileout[i] = '\0';

}

struct tm leggi_soglia (int f_in)
{
	char data[SOGLIALEN],temp = '\0';
	int i = 0,nread = 1;

	struct tm soglia;
	
	ignora_spazi(f_in);
	nread = read(f_in,&temp,sizeof(char));
	
	while(temp != '\n') {
		if(nread == 0) {
			perror("End of file inatteso");
			exit(1);
		}
		
		if(isdigit(temp)) {
			if(i >= SOGLIALEN) {
				perror("La data non  in un formato corretto");
				exit(2);
			}
			data[i++] = temp;
		}
		nread = read(f_in,&temp,sizeof(char));
	}
	data[i] = '\0';
	
	strptime(data,"%d%m%y%H%M%S",&soglia);
	return soglia;
}
	
int leggi_nproc(int f_in)
{
	char nproc[MAXFIGURES],temp = '\0';
	int i = 0,nread = 0,processi = 0;
	for(i=0;i<MAXFIGURES;i++) nproc[i] = '\0';
		
	ignora_spazi(f_in);

	nread = read(f_in,&temp,sizeof(char));
	for(i=0;i< MAXFIGURES && isdigit(temp);i++) {
		nproc[i] = temp;
		nread = read(f_in,&temp,sizeof(char));
	}
	
	if(i >= MAXFIGURES) {
		perror("Il numero dei processi supera le 3 cifre");
		exit(2);
	}
	else if(nread == 0) {
		perror("End of File Inatteso");
		exit(1);
	}
	else if (i==0) {
		perror("Formato del file errato:mi aspettavo almeno una cifra");
		exit(1);
	}
	processi = atoi(nproc);
	
	return processi;
}

void leggi_path(int f_in,int *npath,char **pathnames)
{
	char path[MAXPATHLEN],c;
	*npath = 0;
	int i = 0,nread = 0,j = *npath;
	for(i=0;i<MAXPATH;i++)path[i] = '\0';
	for(i=0;i<MAXPATH;i++) pathnames[i] = NULL;

	ignora_spazi(f_in);
	
	while(((nread = read(f_in,&c,sizeof(char))) != 0) && *npath <= MAXPATH) {
		for(i=0;(i<MAXPATHLEN-1) && (c != '\n') ;i++){
			path[i] = c;
		       	nread = read(f_in,&c,sizeof(char));
			
			/*Se ho finito di leggere il file restituisco l'elenco dei pathnames */
			if(nread == 0) break;
		}

		/*Inserisco il carattere di terminazione stringa */
		if(path[i-1] == '/') path[i-1] = '\0';
		else path[i] = '\0';
		
		pathnames[j] = (char *) malloc (sizeof(char) * i);	
		strncpy(pathnames[j],path,i);

		j++;	/*Incremento il numero dei path memorizzati*/
		if(nread == 0) return ;
		ignora_spazi(f_in);
		*npath=j;
	}
	
	if(*pathnames == NULL) {
		perror("End of file inatteso,non sono stati specificati path da esplorare");
		exit(1);
	}
	
	else if(j > MAXPATH) { 
		perror("Numero di pathname eccessivo,lavorer solo sui primi 1024");
		*npath = j-1;
	}

	return;
}
