#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <linux/unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>

#define MAX_PATH 1000

typedef struct STACK{
	char *path;
	struct STACK *down;
} stack;
typedef stack *stk_p;

void print(stk_p stack);

stk_p push(stk_p stack, char *string)
{
stk_p new;

	new=malloc(sizeof(stack));
	new->path=calloc(strlen(string),sizeof(char));
	new->path=strncpy((new->path),string,strlen(string));
	new->down=stack;
	
	return new;
	
}

// deve tornare una stringa, attento al valore di ritorno
char* pop(stk_p *stack)
{
stk_p temp;
char *ret_string;
	
	if(!(*stack))
		return NULL;
	
	ret_string=calloc(strlen((*stack)->path),sizeof(char));
	ret_string=strncpy(ret_string,(*stack)->path,strlen((*stack)->path));
	temp=*stack;
	*stack=(*stack)->down;
	free(temp);

	return ret_string;
}

void print(stk_p stack)
{
stk_p temp;

	temp=stack;
	while(temp)
	{
		printf("%s\n",temp->path);
		temp=temp->down;
	}

	printf("NULL\n");

}

char *cwd(char *name)
{
char *cwd_path,*ret_string;

	if(!(cwd_path=calloc(MAX_PATH,sizeof(char))))
	{
		perror("calloc");
		exit(1);
	}

	if(!(getcwd(cwd_path,MAX_PATH)))
	{
		perror("getcwd");
		exit(1);
	}

	ret_string=calloc(strlen(cwd_path)+strlen(name)+1,sizeof(char));
	
	ret_string=strncat(ret_string,cwd_path,strlen(cwd_path));
	ret_string[(strlen(cwd_path))]='/';
	ret_string=strncat(ret_string,name,strlen(name));

	return ret_string;
}
	

int main(int argc, char **argv)
{
DIR *cur_dir;
struct dirent *dir_list;
struct stat info;
stk_p stack=NULL;
int fd;
char *dir_path_name,*current_path_name;

	if(argc!=2)
	{
		printf("usage: %s <dir_path>\n",argv[0]);
		exit(1);
	}

	dir_path_name=cwd(argv[1]);
	
	stack=push(stack,dir_path_name);

	//
	while((current_path_name=pop(&stack)))
	{
		// fare una chdir

		free(dir_path_name);

		if(!(cur_dir=opendir(argv[1])))
		{
			perror("readdir");
			exit(1);
		}
	
		while((dir_list=readdir(cur_dir)))
		{
			if((fd=open(dir_list->d_name,O_RDONLY))<0)
			{
				perror("open");
				exit(1);
			}
	
			if((fstat(fd,&info))<0)
			{
				perror("fstat");
				exit(1);
			}
	
			if((close(fd))<0)
			{
				perror("close");
				exit(1);
			}
	
			if(S_ISDIR(info.st_mode))
			{
				printf("directory %s\n",dir_list->d_name);
				
				if((strcmp(dir_list->d_name,"..")!=0) && ((strcmp(dir_list->d_name,"."))!=0))
				{
					dir_path_name=cwd(dir_list->d_name);
					stack=push(stack,dir_path_name);
				}
			}
	
			else
				printf("file : %s\n",dir_list->d_name);
		}
	}

	return 0;
}
	

// ricordare di chiudere le directory e gli eventuali file, di controllare meglio la free sulle stringhe, le operazioni sulle stringe
// fatte da "pop" e....e...boh adios

	
